Package serp.bytecode

# Class ClassInstruction

java.lang.Object
serp.bytecode.Instruction
serp.bytecode.TypedInstruction
serp.bytecode.ClassInstruction

All Implemented Interfaces:
  `BCEntity`, `VisitAcceptor`

Direct Known Subclasses:
  `MultiANewArrayInstruction`

public class ClassInstruction extends TypedInstruction
An instruction that takes as an argument a class to operate on. Examples include `anewarray, checkcast, instance, anew`, etc.

Author:
  Abe White

## Method Summary

Modifier and Type
Method
Description
`void`
`acceptVisit(BCVisitor visit)`
Accept a visit from a `BCVisitor`, calling the appropriate methods to notify the visitor that it has entered this entity, and to provide it with the proper callbacks for each sub-entity owned by this one.
`boolean`
`equalsInstruction(Instruction other)`
ClassInstructions are equal if the type they reference is the same or unset and if their opcodes are equal.
`int`
`getStackChange()`
Return the number of stack positions this instruction pushes or pops during its execution.
`int`
`getTypeIndex()`
Return the `ConstantPool` index of the `ClassEntry` describing the class for this instruction.
`String`
`getTypeName()`
Return the type name for this instruction.
`TypedInstruction`
`setType(String type)`
Set the type of this instruction.
`ClassInstruction`
`setTypeIndex(int index)`
Set the `ConstantPool` index of the `ClassEntry` describing the class for this instruction.

### Methods inherited from class serp.bytecode.TypedInstruction

`getType, getTypeBC, setType, setType`

### Methods inherited from class serp.bytecode.Instruction

`getByteIndex, getClassLoader, getCode, getLineNumber, getLogicalStackChange, getName, getOpcode, getPool, getProject, isValid`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

## Method Details

### getStackChange

public int getStackChange()
Description copied from class: `Instruction`
Return the number of stack positions this instruction pushes or pops during its execution.

Overrides:
  `getStackChange` in class `Instruction`
Returns:
  0 if the stack is not affected by this instruction, a positive number if it pushes onto the stack, and a negative number if it pops from the stack

### getTypeIndex

public int getTypeIndex()
Return the `ConstantPool` index of the `ClassEntry` describing the class for this instruction.

### setTypeIndex

public ClassInstruction setTypeIndex(int index)
Set the `ConstantPool` index of the `ClassEntry` describing the class for this instruction.

Returns:
  this instruction, for method chaining

### getTypeName

public String getTypeName()
Description copied from class: `TypedInstruction`
Return the type name for this instruction. If the type has not been set, this method will return null.

Specified by:
  `getTypeName` in class `TypedInstruction`

### setType

public TypedInstruction setType(String type)
Description copied from class: `TypedInstruction`
Set the type of this instruction. Types that have no direct support will be converted accordingly.

Specified by:
  `setType` in class `TypedInstruction`
Returns:
  this instruction, for method chaining

### equalsInstruction

public boolean equalsInstruction(Instruction other)
ClassInstructions are equal if the type they reference is the same or unset and if their opcodes are equal.

Overrides:
  `equalsInstruction` in class `Instruction`

### acceptVisit

public void acceptVisit(BCVisitor visit)
Description copied from interface: `VisitAcceptor`
Accept a visit from a `BCVisitor`, calling the appropriate methods to notify the visitor that it has entered this entity, and to provide it with the proper callbacks for each sub-entity owned by this one.

Specified by:
  `acceptVisit` in interface `VisitAcceptor`
Overrides:
  `acceptVisit` in class `Instruction`